package jrf.hbset.util;

import java.util.List;

public interface HBSet {
	//abstract  Comparison compare(HBSet other);
	//abstract  int[] get_serialized_hb();
	abstract  int[] get_table_entry();
	abstract  int get_table_size();
	abstract  List<KeyPair> allocate(Key o, boolean isVolatile);
	abstract  void norace(Key t, Key o);
	abstract  boolean verify(Key a, Key o);
	abstract  void acquire(Key t, Key o);
	abstract  void release(Key t, Key o);
	abstract  void invalidate(Key t, Key o);
//	abstract  void clean(Key o);
	abstract  void deallocate(Key o, boolean isVolatile);
	abstract  void add(Key o1, Key o2);
	
	abstract  void remove(Key o1, Key o2);
	abstract  MySet<Key> get_hb_set(Key o); // returns the hbSet of o
	abstract  MySet<Key> get_key_set(Key o); // returns the Keys which has o in their hbSet
	
	abstract  Key get_written_by(Key o);
	abstract  Key set_written_by(Key t, Key o);
	abstract  Key get_prior_release(Key o);
	abstract  Key set_prior_release(Key t, Key o);
	abstract  HBSet clone();
	abstract  boolean is_hb_member(Key o);
	abstract  boolean is_column_member(Key o);
	abstract MySet<Key> get_row();
	abstract MySet<Key> get_column();
}

