package jrf.hbset.util;

import gov.nasa.jpf.JPF;
import gov.nasa.jpf.jvm.Transition;
import gov.nasa.jpf.search.Search;

import java.util.logging.Level;
import java.util.logging.Logger;

public class Log {

	static Logger javalog = JPF.getLogger("jrf.hbset.util");
	public static final int EMPTY=-1;
	
	public static void log(String msg)
	{
		//javalog.warning(msg);
	}
	public static void logStack(String msg)
	{
		//javalog.warning(msg);
	}
	public static void logHBSet(String msg)
	{
		//javalog.warning(msg);
	}
	public static void logState(String msg)
	{
		//javalog.warning(msg);
	}
	public static void logSearch(String msg, Search search)
	{
		
		Transition trans = search==null?null:search.getTransition();  // acquire last transition

	    // (list of executed insns)
	    if (trans != null) 
	       msg = msg+trans.getThreadIndex()+" "+ search.getStateNumber()+" "+search.getDepth()+" : "+trans.getLabel();
System.out.println(msg);
		//javalog.warning(msg);
		 
		 
	}
	public static void logSystemSkip(String msg)
	{
		//javalog.warning(msg);
	}
	public static void logACH(String msg)
	{
		//javalog.warning(msg);
	}
	public static void logInstruction(String msg)
	{
		//System.out.println(msg);
		//javalog.warning(msg);
	}
	public static void logResult(String msg)
	{
		//javalog.warning(msg);
	}
	public static void logRace(String msg)
	{
		//javalog.severe(msg);
	}
}
