package jrf.search;

import jrf.hbset.ListenerHBmanagement;
import jrf.listener.HBSearchListener;

import gov.nasa.jpf.Config;
import gov.nasa.jpf.jvm.JVM;
import gov.nasa.jpf.search.DFSearch;

public class HBDFSearch extends DFSearch implements HBSearch {
	
	public HBDFSearch(Config config, JVM vm) {
		super(config, vm);
		ListenerHBmanagement.setRestore_LIFO_Order();
	}

	@Override
	public boolean isNewState () {
		boolean isNew = super.isNewState();
		if ( !isNew && !HBSearchListener.isCoveredState(vm.getStateId(), true) )
				isNew = true;
	    return isNew;
	  }
}
