package jrf.stub;

import gov.nasa.jpf.jvm.ElementInfo;
import gov.nasa.jpf.jvm.FieldInfo;
import gov.nasa.jpf.jvm.JVM;
import gov.nasa.jpf.jvm.ThreadInfo;
import jrf.hbset.util.AbstractArrayImpl;
import jrf.listener.JRFListener;

public class HBmanagementStub {

	//By KyungHee
//	private static int count;
	public static void enter(String name)
	{
/*		
	for ( int i=0 ; i < count ; ++i) System.out.print("---");
	System.out.println(">"+name);
	count++;
*/		 
	}
	public static void exit(String name)
	{
/*		
	count--;
	System.out.print("<");
	for ( int i=0 ; i < count ; ++i) System.out.print("---");
	System.out.println(name);
*/		 
	}

	public static void READ(ThreadInfo ti, ElementInfo ei, FieldInfo fi)
	{
		String listener = JVM.getVM().getConfig().getProperty("listener");
		if ( listener != null && listener.contains("jrf.listener.JRFListener") ) {
			int fn = 0;
			//String fname = null;
			for ( int i=0 ; i < ei.getNumberOfFields() ; ++i )
			{
				FieldInfo fld = ei.getFieldInfo(i);
				if ( fld == fi ) 
				{
					fn = i+1;
					//fname = fi.getName();
					break;
				}
			}
			assert(fn!=0):"Cannot decide Field Number of \""+fi.getName()+"\".";
			AbstractArrayImpl.READ(ti, ei, fi, fn, fi.isVolatile(), JRFListener.isWithinStaticInit(ti));
		}
	}
	
	public static void READ(ThreadInfo ti, ElementInfo ei, int fn)
	{
		String listener = JVM.getVM().getConfig().getProperty("listener");
		if ( listener != null && listener.contains("jrf.listener.JRFListener") ) {
			AbstractArrayImpl.READ(ti, ei, null, fn, false, JRFListener.isWithinStaticInit(ti));
		}
	}

	public static void WRITE(ThreadInfo ti, ElementInfo ei, FieldInfo fi)
	{
		String listener = JVM.getVM().getConfig().getProperty("listener");
		if ( listener != null && listener.contains("jrf.listener.JRFListener") ) {
			int fn = 0;
			// String fname = null;
			for ( int i=0 ; i < ei.getNumberOfFields() ; ++i )
			{
				FieldInfo fld = ei.getFieldInfo(i);
				if ( fld == fi ) 
				{
					fn = i+1;
					//	  fname = fi.getName();
					break;
				}
			}
			assert(fn!=0):"Cannot decide Field Number of \""+fi.getName()+"\".";
			AbstractArrayImpl.WRITE(ti, ei, fi, fn, fi.isVolatile(), JRFListener.isWithinStaticInit(ti));
		}
	}
	
	public static void WRITE(ThreadInfo ti, ElementInfo ei, int fn)
	{
		String listener = JVM.getVM().getConfig().getProperty("listener");
		if ( listener != null && listener.contains("jrf.listener.JRFListener") ) {
			AbstractArrayImpl.WRITE(ti, ei, null, fn, false, JRFListener.isWithinStaticInit(ti));
		}
	}
}
