package jrf.hbset.util;

import java.util.ArrayList;

public class PathElementList {
	ArrayList<PathElement> list = new ArrayList<PathElement>();
	int current_index=0;
	
	public void add(Key memObj)
	{
		++current_index;
		if ( memObj != null )
			list.add(new PathElement(current_index, memObj));
	}
	
	public Key get(int _index)
	{
		for ( int i=list.size() ; i > 0 ; --i)
		{
			PathElement p = list.get(i-1);
			if ( p.index == _index ) return p.key;
			else if ( p.index < _index ) return null;
		}
		return null;
	}
	
	public PathElementList clone()
	{
		PathElementList copy = new PathElementList();
		copy.list = (ArrayList<PathElement>)list.clone();
		copy.current_index = current_index;
		return copy;
	}
	
	public int size()
	{
		return current_index;
	}

	public void remove(int _index) {
		--current_index;
		int i;
		for (  i=list.size() ; i > 0 ; --i)
		{
			PathElement p = list.get(i-1);
			if ( p.index == _index ) break;
			else if ( p.index < _index ) return;
		}
		if ( i > 0 ) list.remove(i-1);
	}
}